"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const toast_1 = require("primereact/toast");
const app_1 = require("firebase/app");
const messaging_1 = require("firebase/messaging");
const NotificationProvider = ({ firebaseConfig, children }) => {
    const toast = react_1.default.useRef(null);
    (0, react_1.useEffect)(() => {
        let app;
        if (!(0, app_1.getApps)().length) {
            app = (0, app_1.initializeApp)(firebaseConfig);
        }
        else {
            app = (0, app_1.getApps)()[0]; // Use the existing initialized app
        }
        const messaging = (0, messaging_1.getMessaging)(app);
        Notification.requestPermission().then((permission) => {
            if (permission === 'granted') {
                console.log('Notification permission granted.');
                (0, messaging_1.onMessage)(messaging, (payload) => {
                    console.log('Message received. ', payload);
                    const notificationType = payload.notification?.title || 'info';
                    let message = {
                        severity: 'info',
                        summary: 'Notification',
                        detail: payload.notification?.body,
                        life: 3000,
                    };
                    switch (notificationType) {
                        case 'success':
                            message.severity = 'success';
                            break;
                        case 'error':
                            message.severity = 'error';
                            break;
                        case 'warn':
                            message.severity = 'warn';
                            break;
                        default:
                            message.severity = 'info';
                    }
                    toast.current?.show(message);
                });
            }
            else {
                console.log('Unable to get permission to notify.');
            }
        }).catch((err) => {
            console.error('An error occurred while retrieving token. ', err);
        });
        // Empty dependency array to ensure this runs only once
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(toast_1.Toast, { ref: toast }),
        children));
};
exports.default = NotificationProvider;
