"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var toast_1 = require("primereact/toast");
var firebaseConfig_1 = require("../firebaseConfig");
var messaging_1 = require("firebase/messaging");
var NotificationToaster = function (_a) {
    var firebaseConfig = _a.firebaseConfig, vapidKey = _a.vapidKey;
    var toastRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        var messaging = (0, firebaseConfig_1.getMessagingInstance)(firebaseConfig);
        (0, messaging_1.getToken)(messaging, { vapidKey: vapidKey })
            .then(function (currentToken) {
            if (currentToken) {
                console.log('Current token:', currentToken);
                // TODO: Send token to your server
            }
            else {
                console.log('No registration token available.');
            }
        })
            .catch(function (err) {
            console.error('An error occurred while retrieving token.', err);
        });
        var unsubscribe = (0, messaging_1.onMessage)(messaging, function (payload) {
            var _a;
            console.log('Message received. ', payload);
            var _b = payload.notification || {}, title = _b.title, body = _b.body, type = _b.type;
            (_a = toastRef.current) === null || _a === void 0 ? void 0 : _a.show({
                severity: type || 'info',
                summary: title || 'Notification',
                detail: body || 'You have a new notification!',
                life: 3000
            });
        });
        // Clean up the subscription
        return function () {
            unsubscribe();
        };
    }, [firebaseConfig, vapidKey]);
    return (react_1.default.createElement(toast_1.Toast, { ref: toastRef }));
};
exports.default = NotificationToaster;
