import { useEffect } from 'react';
import { getMessaging, onMessage } from 'firebase/messaging';
import { initializeApp, getApps } from 'firebase/app';
export var useFirebaseMessaging = function (firebaseConfig, onNotification) {
    useEffect(function () {
        var app;
        if (!getApps().length) {
            app = initializeApp(firebaseConfig);
        }
        else {
            app = getApps()[0];
        }
        var messaging = getMessaging(app);
        Notification.requestPermission().then(function (permission) {
            if (permission === 'granted') {
                console.log('Notification permission granted.');
                onMessage(messaging, function (payload) {
                    console.log('Message received. ', payload);
                    onNotification(payload);
                });
            }
            else {
                console.log('Unable to get permission to notify.');
            }
        }).catch(function (err) {
            console.error('An error occurred while retrieving token. ', err);
        });
    }, [firebaseConfig, onNotification]);
};
