"use strict";
exports.__esModule = true;
var app_1 = require("firebase/app");
var sw_1 = require("firebase/messaging/sw");
// Firebase configuration
var firebaseConfig = {
    apiKey: process.env.REACT_APP_FIREBASE_API_KEY,
    authDomain: process.env.REACT_APP_YOUR_AUTH_DOMAIN,
    projectId: process.env.REACT_APP_YOUR_PROJECT_ID,
    storageBucket: process.env.REACT_APP_YOUR_STORAGE_BUCKET,
    messagingSenderId: process.env.REACT_APP_YOUR_MESSAGING_SENDER_ID,
    appId: process.env.REACT_APP_YOUR_APP_ID
};
// Initialize Firebase
var app = (0, app_1.initializeApp)(firebaseConfig);
var messaging = (0, sw_1.getMessaging)(app);
// Handle background messages
(0, sw_1.onBackgroundMessage)(messaging, function (payload) {
    var _a, _b;
    console.log('Received background message ', payload);
    var notificationTitle = ((_a = payload.notification) === null || _a === void 0 ? void 0 : _a.title) || 'Notification';
    var notificationOptions = {
        body: ((_b = payload.notification) === null || _b === void 0 ? void 0 : _b.body) || 'You have a new message.',
        icon: '/firebase-logo.png'
    };
    // Show notification
    self.registration.showNotification(notificationTitle, notificationOptions);
});
